%{

/*
   conf.y -- PIKT parser for the PIKT.conf file

   $Header: /home/cvs/ucgsb/pikt/src/lib/conf.y,v 1.4 1999/10/04 05:14:45 harlan Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-99 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

#include "common.h"

%}

%union {
	int ival;
	char *sval;
}

%token <sval> _PARSTR _PARINT _PARSRV _PARBOL
%token _SYSLOGFAC
%token <sval> _STR
%token <ival> _INT _BOL

%%

start:		conflines
		;

conflines:	confline
		| conflines confline
		;

confline:	_PARSTR _STR {
			setstr($1, confparstrp, $2);
			free($1);
		}
		| _PARINT _INT {
			setint($1, confparintp, $2);
			free($1);
		}
		| _PARSRV _BOL {
			setsrv($1, confparsrv, $2);
			free($1);
		}
		| _PARBOL _BOL {
			setint($1, confparintp, $2);
			free($1);
		}
		| _SYSLOGFAC _INT {
			switch ($2) {
				case 0:
					syslog_facility = LOG_LOCAL0;
					break;
				case 1:
					syslog_facility = LOG_LOCAL1;
					break;
				case 2:
					syslog_facility = LOG_LOCAL2;
					break;
				case 3:
					syslog_facility = LOG_LOCAL3;
					break;
				case 4:
					syslog_facility = LOG_LOCAL4;
					break;
				case 5:
					syslog_facility = LOG_LOCAL5;
					break;
				case 6:
					syslog_facility = LOG_LOCAL6;
					break;
				case 7:
					syslog_facility = LOG_LOCAL7;
					break;
				default:
					fprintf(stderr, "in PIKT.conf, invalid syslog_facility %d\n", $2);
					fflush(stderr);
					bailout = TRUE;
					break;
			}
		}
		;

%%
